package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.bo.CourseChapterAddBo;
import com.zhongzheng.modules.course.bo.CourseChapterEditBo;
import com.zhongzheng.modules.course.bo.CourseChapterQueryBo;
import com.zhongzheng.modules.course.domain.CourseChapter;
import com.zhongzheng.modules.course.mapper.CourseChapterMapper;
import com.zhongzheng.modules.course.service.ICourseChapterService;
import com.zhongzheng.modules.course.vo.CourseChapterVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 课程大章Service业务层处理
 *
 * @author hjl
 * @date 2021-05-19
 */
@Service
public class CourseChapterServiceImpl extends ServiceImpl<CourseChapterMapper, CourseChapter> implements ICourseChapterService {

    @Override
    public CourseChapterVo queryById(Long chapterId){
        CourseChapter db = this.baseMapper.selectById(chapterId);
        return BeanUtil.toBean(db, CourseChapterVo.class);
    }

    @Override
    public List<CourseChapterVo> queryList(CourseChapterQueryBo bo) {
        LambdaQueryWrapper<CourseChapter> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getCourseId() != null, CourseChapter::getCourseId, bo.getCourseId());
        lqw.like(StrUtil.isNotBlank(bo.getName()), CourseChapter::getName, bo.getName());
        lqw.eq(bo.getSort() != null, CourseChapter::getSort, bo.getSort());
        lqw.in(bo.getStatus() != null, CourseChapter::getStatus, bo.getStatus());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<CourseChapterVo> entity2Vo(Collection<CourseChapter> collection) {
        List<CourseChapterVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, CourseChapterVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<CourseChapter> page = (Page<CourseChapter>)collection;
            Page<CourseChapterVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(CourseChapterAddBo bo) {
        CourseChapter add = BeanUtil.toBean(bo, CourseChapter.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(CourseChapterEditBo bo) {
        CourseChapter update = BeanUtil.toBean(bo, CourseChapter.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(CourseChapter entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
